\ provisorisk xy ----------------------------
: koomangel?  ( -- f )  \ punkt utan koo
	ntal2 @ ntal @ < ;

: ormangel? ( -- f ) \ alle retningsobs orienterte?
	#orienterte @  hv-oppsamlar nip nip < ;

: provfullt? ( -- f ) \ provisorisk verdi p alle ukjente 
	koomangel? 0= \ ntal2 @ ntal @ =
	ormangel?  0= \ #orientert @  #orienteringar @ = 
	and ;

: nullauke?  ( -- f )  \ ingen auke i antal med koo
	ptalauka @ 0= ;

: #koopkt  ( -- n )  \ gitte + provisoriske pkt 
	ptal @ ntal @ - ntal2 @ + ;

: #LengdeObs ( -- n ) LS-oppsamlar nip nip ;
: #RetninObs ( -- n ) HV-oppsamlar nip nip ;

: OrientEvt ( -- )
	ormangel?  #koopkt 1 > AND  #RetninObs 0> AND  
	IF  provor  THEN ;

INTEGER DARRAY OE{   \ orienteringselement, eitt pr stasjon med orientering
: -OE   & OE{ }free ;
: +OE ( n -- )   & OE{ SWAP }malloc  malloc-fail? ABORT" OEmalloc failed" ;

: OV>OE ( -- ) \ kopier orientering fr sikt
	AlleSikt DO
		i HarRetningsobs? IF
			OV{ i } @ OE{ ORNR{ i } @ } !
		THEN
	LOOP ;

: .OEprov   cr
	." Stasjonar med provisorisk orientering " #orienteringar ? ;

: .OE ( -- )
	.OEprov
	#orienteringar @ 0 DO  cr i . OE{ i } @ .gon  LOOP ;

: .OE1 ( -- )
	#orienteringar ?
	#orienteringar @ 0 DO  cr i . OE{ i } @ .gon  LOOP ;

\ ------------------------------------------------------------
: 0ov ( -- ) AlleSikt DO  0 OV{ i } !  0 RV{ i } !  LOOP ;

: FramskjEvt ( -- )
	#RetninObs 2 >
	ptal @ 2 >
	AND   IF
		provframskj provor
	THEN ;

: PolartEvt ( -- )
	#orienterte @ 0>
	ptal @ 1 >
	AND   IF
		provpolar provor
	THEN ;

: TilbskjEvt ( -- )
	ptal @ 2 >
	IF
		provtilbakeskj provor
	THEN ;

: BuebuebueEvt ( -- )
	ptal @ 2 >
	IF
		provbuebuebue provor
	THEN ;

: 0auke ( -- ) false ptalauka ! ; \ ntal2 @  ntalgml ! ;

: provslutt? ( -- f )  provfullt? nullauke? or ;

: LRnett
	OrientEvt
	BEGIN
		0auke
		PolartEvt
		FramskjEvt   TilbskjEvt
		BuebuebueEvt
		provslutt?
	UNTIL ;

: Rnett
	OrientEvt
	Begin
		0auke
		FramskjEvt   TilbskjEvt
		provslutt?
	UNTIL ;

: Lnett
	Begin
		0auke
		BuebuebueEvt
		provslutt?
	UNTIL ;

: provisoriske3 ( -- ) 
	#LengdeObs #RetninObs and IF  LRnett  ELSE
	#RetninObs                IF   Rnett  ELSE
	Lnett THEN THEN ;

: VisProv ( -- )
          S" filc.txt" DELETE-FILE  DROP
	ptal @ +NYPNR  nullnypkt 0 #orienterte ! 0ov
	provisoriske3  
	.ptabell+on  .o ( vis ) 
	..ptabell+on   ..vissikt ;  \ til filer

: prov2 ( -- f )
	VisProv        cr           
	ntal2 @   IF
		#orienteringar @ +OE
		OV>OE cr .oe
		true
	ELSE
		false
	THEN ;

