\ Inndata-lesing 2.gong
\ Tolking og lagring av pkt og sikt i tabellar

\ -------------------------tolk til tabell------------------------------ 

\ Koordinatar i tabellane er reduserte, falsk origo
: reduserxy ( x y -- x' y' )
	xymin 2@ k- ;

: namn>tabell  ( a u - )
   P{ ptal @ } ( a1 u a2 )   DUP 16 BLANK
   SWAP CMOVE ;
\ ---------------------------------------------------------------------
: fra>tabell  ( a u - )
   SFRA{ stal @ } ( a1 u a2 )   DUP 16 BLANK
   SWAP CMOVE ;

: til>tabell  ( a u - )
   STIL{ stal @ } ( a1 u a2 )   DUP 16 BLANK
   SWAP CMOVE ;
\ --------------------2.lesing - for fpkt---------------------
\ Henting frå mellombels struktur
\ : @fixf  ( kolonne -- f n )  koflag{ over } @ swap @fix ; \ jfr @fix0
\ : @fixand ( kolonne -- n ) \ n=0 dersom flagg er false
\	@fixf and ;
\ Inndataformat: P x y og P1 P2 HV LS VV i s ( 1.kolonne har nr 0 )
\ HV treng flagget vidare, null kan ikkje representera umålt
: Koo@ ( -- x y h ) meterkomma   1 @fix 2 @fix 3 @fix ;
: LS@ ( -- Ls )   meterkomma   kolonneLS @fixf AND ;
: VV@ ( -- vv )   gonkomma     kolonneVV @fixf AND ;
: HV@ ( -- hv f ) gonkomma     kolonneHV @fixf ( f hv ) swap ;
: IS@ ( -- i s )  meterkomma   kolonnei  @fixand  kolonnes @fixand ;

: flag>vekt ( f -- 0|1 ) negate ; \ provisorisk vekt=1

: koo>tabell ( -- )
	KOSTRENG{ 0 } 2@   namn>tabell
	Koo@  H{ ptal @ } !  reduserxy  XY{ ptal @ } 2!
	3 opphav{ ptal @ } !   \ 3 = gitt pkt
	1 ptal +! ;

: VV>tabell  ( -- ) VV@ ( vv ) dup  swap flag>vekt ( Vv vekt ) 
	VVvekt{ stal @ } !  VV{ stal @ } ! 
	IS@ ( i s ) IS{ stal @ } 2! ;
	
: HV>tabell  ( -- ) HV@ ( hv f )   flag>vekt ( Hv vekt ) 
	HVvekt{ stal @ } !  HV{ stal @ } ! ;

: LS>tabell  ( -- ) LS@  dup 0= 0= flag>vekt ( L vekt )
	LSvekt{ stal @ } !  LS{ stal @ } ! ;
	
: obs>tabell ( -- ) \ obs får provisorisk vekt=1
	KOSTRENG{ 0 } 2@   fra>tabell     \ pkt1
	KOSTRENG{ 1 } 2@   til>tabell     \ pkt2
	HV>tabell 
	LS>tabell  
	VV>tabell    \ vv i og s
	1 stal +! ;

: TilTabell ( -- ) \ cr #desimalarg . . 
	koo-linje? IF  koo>tabell  EXIT THEN
	obs-linje? IF  obs>tabell  EXIT THEN 
	cr ." Linje utan koo eller obs" ;

: TolkLinje ( a u -- )
	1 #linjer +!
	DUP IF 
		datalinje?
		IF   1 #datalinjer +!  TilTabell  THEN
	ELSE
		2DROP   \ utan innhald
	THEN ;

: filinn
   0 #linjer !		0 stal !
   for-each-read   DUP  IF   TolkLinje   ELSE   2DROP   THEN
   REPEAT
   Close-Input  
   CR #linjer ? ." linjer leste"   ;

\ ---------------------fil------------------------
\ 1.lesing oversikt over innhald i fila
\ 2.lesing overfører innhald til tabellar i RAM

: .UtInndata   .ptabell0 .sikt ;

: 2.lesing ( -- sann=ok )
	\ testfil @ TO Input-File   
	filinn
      CR ." Punktantal: " ptal ? ." av maks " pktmax .
      CR ." Siktantal: " stal ? ." av maks " siktmax . 
	 ptal @ 1 >   stal @ 1 > AND ; \ minstekrav til antal
	  
: inndata0 (  -- sann=ok ) \ plass-p  
	#obslinjer @ ( dup +SIKT ) +PS
	0 ptal !  0 stal !  2.lesing (  .ptabell0  .sikt ) ;

: fagdata? ( -- flag ) \ relevante data?
	#koolinjer @ 1 >  ( f1 )
	#obslinjer @ 1 >  ( f1 f2 )
	#koolinjer @ #obslinjer @ + 2* #linjer @ > ( f1 f2 f3 )
	AND AND ( f ) ;

: inndata ( -- flag ) 
	1.lesing ( linjer ) 
	fagdata? ( linjer f )  AND
	IF   inndata0 .UtInndata   ELSE   false   THEN ;

