\ Opning og lesing av datafiler

0 [IF]
\ READ-LINE -----------------------------

10 CONSTANT \n
13 CONSTANT \r

0 VALUE a   0 VALUE u   0 VALUE f

\ This treats \n, \r\n, and \r as line terminator.  Reading is done
\ one char at a time with READ-FILE hence READ-FILE should probably do
\ some form of buffering for good efficiency.
\ Her bare \n !
: READ-LINE ( c-addr u1 fileid -- u2 flag ior )
    TO f   TO u   TO a   \   { a u f }
    u 0 ?DO
        a I CHARS + 1 f READ-FILE                                  ( u ior' )
        ?DUP IF nip I FALSE ROT UNLOOP EXIT THEN \ Read error?     ( u )
\		IF ABORT" lesefeil" THEN
        0= IF  I I 0<> 0 UNLOOP EXIT  THEN         \ End of file?    ( )
		a I CHARS + C@
		\n = IF   I TRUE 0  UNLOOP EXIT THEN
	LOOP    
	\ Line doesn't fit in buffer
	u TRUE 0 ;
[THEN]


\ ----- Traverse-file av Wil Baden -------------------------------

0 VALUE Input-File
0 VALUE Input-Line
0 VALUE Input-Length 

128 CONSTANT Normal-Input-Length
   
CREATE Normal-Input-Line   Normal-Input-Length 2 + CHARS ALLOT

    : Read-Input                    ( -- str len more )
        Input-Line DUP Input-Length Input-File  READ-LINE ( a u2 f ior ) 
            ABORT" Can't READ-LINE " ;

    : Rewind-File ( file-id -- ior ) 0 0 ROT REPOSITION-FILE ;

    : Rewind-Input                  ( -- )
        Input-File  Rewind-File ABORT" Can't REWIND-FILE " ;

    : Close-Input                   ( -- )
        Input-File  CLOSE-FILE ABORT" Can't CLOSE-FILE " ;

\  `FOR-EACH-READ` is a macro and can be defined with `EVALUATE`

     : for-each-read                ( C: -- orig dest )( -- str len )
          S" Rewind-Input  BEGIN  Read-Input   ?DUP AND ?DUP AND   WHILE "
          EVALUATE ; IMMEDIATE

\ testing ------------------------------------------------------------
testing [IF]
 : .mfv                  ( -- )
       CR Input-File  .
       CR Normal-Input-Line . Input-Line .
       CR Normal-Input-Length . Input-Length . ;

 : pf1 ( -- a u2 f )
    for-each-read
	( str len)   \ evt TRAVERSE-INPUT
        CR TYPE \  process a record of the file ( )
    REPEAT
    Close-Input  ;

 : Show-Input                    ( -- )
    for-each-read
	TYPE CR  REPEAT ;
[THEN]

\ filval ------------------------------------------------------

: fil!                  ( fid -- )
       TO Input-File
       Normal-Input-Line TO Input-Line
       Normal-Input-Length TO Input-Length ;

: opne ( a u -- f )
	r/o OPEN-FILE ( fid ior )
	0= IF   fil! true ELSE  CR ." Fil ikkje funne! " false  THEN ;

\ for innstasting av inndatafilnamn
0 [IF]
: input$ ( - a u )  PAD 1+   127 ACCEPT PAD C! PAD COUNT ;

: sti ( -- a u )
	CR ." Inndatafil: "   input$ 	\ inntasta fil
	DUP 0= IF 
		DROP
		demo 2@ ( a u )
	THEN ;
[THEN]

\ sti til parameterfil, oppretta av gui
\ S" /home/jostein/ftmp.txt"   2constant parametersti
\ 2variable inndatasti              \ sti til inndatafil,     jfr i last.fth

: FinnInnfil ( -- a u )
    parametersti opne ( f )       \ opne parameterfil
    IF   
        Read-Input drop  ( a u )  \ les parameterfil ei linje
		Close-Input               \ steng parameterfil
    ELSE   
        ."    parameterfil ikkje opna! "
    THEN ;
    
: AnsFilval ( -- f ) \ finn og opn inndatafil
    FinnInnfil ( a u )
\	skjermskriv
	DUP IF cr 2DUP TYPE opne ELSE false THEN ;

\ -------------- datafiler slutt ------------------------------


0 VALUE Andrefid      \ fid for fil 2

: OpprettFil ( a u -- ior )
	R/W CREATE-FILE
	0= IF TO Andrefid true ELSE  ."    Fil ikkje laga! " false  THEN ;
	
: opne-rw ( a u -- ior )
	R/W OPEN-FILE ( fid ior )
	0= IF TO Andrefid true ELSE  ."    Fil ikkje funne! " false  THEN ;

