\ : z .s key DROP ;

\ struktur for mellombels lagring av innhald I ei linje
\ Første delstreng frå venstre er streng0. Strengar lagra
\ som adr u. Antal opp til øvre verdi i "forventa"
\ Flag sant dersom konvertering til tall er velykka.
\ Da er num tallet og dpl antall siffer bak evt desimalteikn.
\ For ikkje-konverterbar streng er num, dpl og flag null.
\ NB: num=0 kan vera gyldig tall. Da er flag sant.
\ -------------------------------------------------
\ streng0 | streng1 | streng2 | streng3 | streng4 |  KOSTRENG{
\ -------------------------------------------------
\ num0    | num1    | num2    | num3    | num4    |  KOLONNE{
\ dpl0    | dpl1    | dpl2    | dpl3    | dpl4    |
\ -------------------------------------------------
\ flag0   | flag1   | flag2   | flag3   | flag4   |  KOFLAG{
\ --------------------------------------------------
3 8 2CONSTANT forventa   \ nedre og øvre tillatte kolonneantal
VARIABLE #kolonnar       \ funne kolonneantal
forventa nip double array KOSTRENG{  \ a u
forventa nip double array KOLONNE{  \ n dpl
forventa nip integer array KOFLAG{  \ streng | tall

testing [IF]
: .kol  \ vis innhald i aktuell linje
	3 places
	CR #kolonnar @ 0 DO   kostreng{ I } 2@ TYPE 5 SPACES  LOOP ."  streng   " #kolonnar ?
	CR #kolonnar @ 0 DO   kolonne{ I } 2@ DROP 12 .R   LOOP ."  num"
	CR #kolonnar @ 0 DO   kolonne{ I } 2@ nip 12 .R   LOOP ."  dpl"
	CR #kolonnar @ 0 DO   koflag{ I } @  12 .R   LOOP ."  flag"
	4 places
	CR #kolonnar @ 0 DO   kolonne{ I } 2@ fixa 12 x.R   LOOP ."  fix" ;
[THEN]
\ ----------------------------------------------------------

maxmin+-: x-oppsamlar
maxmin+-: y-oppsamlar
logg:     h-oppsamlar


VARIABLE #linjer
VARIABLE #datalinjer
\ ------------------

: 1cells ( n -- n dpl flag )
	DPL @   true ;

\ double number med null i øvre celle går som single
\ double number med -1 i øvre celle går som single
\ double number med anna i øvre celle er for store

: 2cells ( n . -- n dpl -1 | 0 0 0 )
	dup 0= IF  D>S 1cells  ELSE
	dup -1 = IF  D>S 1cells  ELSE
	CR ." For stort tall" DROP 0 0 false ( 0 0 0 )
	THEN THEN ;

: >tall ( a u -- n dpl -1 | 0 0 0 )      \ konverter
	tall? ( 0 | n 1 | n . 2 )
	DUP 1 = if DROP 1cells   exit then  \ tall i 1 celle
	DUP 2 = if DROP 2cells   exit then  \ double number
	0 0 ;         \ ikkje konverterbar
	
: 0koflag forventa nip 0 do  false koflag{ i } !  loop ;

: linje>tall ( au au au ... n -- )
	DUP #kolonnar !   0koflag
	1 - 0
	swap DO
		2dup kostreng{ I } 2! ( au )   \ lagr delstreng
		>tall ( n dpl -1 | 0 0 0 )      \ konverter til tall
		koflag{ I } !                  \ konverterbar?
		kolonne{ I } 2!                \ lagr tall og dpl
	-1 +LOOP ;

: datalinje? ( a u -- flag )
\	( dup 1 > IF  )  del-linje   ELSE 1   THEN ( au au au ..n ) 
	del-linje   ( au au au ..n )
	DUP forventa WITHIN if 
		linje>tall true     \ lagr delstrengar og tall
	else
		dropp false
	then ;

\ henting frå mellombels struktur
: gyldig? ( i --flag )
	koflag{ swap } @ ;

: @fix ( I -- nfix )   \ hent og fix, bruk f#places
	dup gyldig? IF
		kolonne{ swap } 2@ ( n dpl ) fixa 
	ELSE
		drop 0 
	THEN ;

: @fix0 ( I -- nfix )   \ hent og fix, kutt desimalar
	kolonne{ swap } 2@ ( n dpl ) fix0 ;

\ analyse generelt--------------------------
VARIABLE #koolinjer
VARIABLE #obslinjer
\ VARIABLE testfil 

: UTMX? ( -- flag )
	koflag{ 1 } @ if 
		1 @fix0
		6000000 7000000 within
	else
		FALSE
	then ;
	
: NGOX? ( -- flag )
	koflag{ 1 } @ if 
		1 @fix0
		150000 170000 within
	else
		FALSE
	then ;

: koo-linje? ( -- flag )
	UTMX? NGOX? or ;

: obs-linje? ( -- flag )   \ linje utan x, med retn, len eller vert.v
	UTMX? NGOX? or 0=          \ ikkje x-koo
	0
	2 #kolonnar @ 1 - 	do \ unntatt kolonne 0 og 1
		koflag{ i } @ MIN
	-1 +loop          \ minst ein numerisk
	AND ;

