\ Kopling av punkt og sikt, v.hj.a. punktnamn
\ Gr uendra for V- og L-nett

\ definer seinare PKT som FRA eller TIL
DEFER SPKT{
DEFER SPKTNR{

: kople1 ( snr pnr - )                 \ kople eitt endepkt
   SPKTNR{ ROT } ! ;   

: nypkt ( snr - )
   DUP SPKT{ SWAP }   ( snr a1 )       \ namn i sikt
   P{ ptal @ } 16 ( snr a1 a2 u )      \ frste ledige pktplass
   CMOVE
   ptal @ 0pkt
   0 opphav{ ptal @ } !				\ opphavskode til pktet
   ptal @ ( snr pnr ) kople1           \ kople sikt til nypkt
   1 ptal +! ;                         \ auk antall pkt

: kopling-ok? ( snr pnr - flagg )      \ dersom like namn, kople
   2DUP >R >R
   P{ SWAP } 16 ( snr a u )
   ROT SPKT{ SWAP } 16 ( a u a u )
   S= R> R> ROT IF kople1 TRUE ELSE 2DROP FALSE THEN ;

: sikt=>pkt ( - )                       \ samkyr sikttabell og pkttabell
   AlleSikt DO
      -1   ( flagg1 )                      \ -1 = ukopla 
      AllePkt DO
         J I kopling-ok? ( flagg2 )
         IF DROP 0 ( flagg1 ) LEAVE THEN   \ 0 = kopla
      LOOP
      ( flagg1 ) IF I nypkt THEN           \ nypkt dersom ukopla
   LOOP ;

: kople-f ( - )
   ['] SFRA{ IS SPKT{
   ['] SFRANR{ IS SPKTNR{
   sikt=>pkt ;

: kople-t ( - )
   ['] STIL{ IS SPKT{
   ['] STILNR{ IS SPKTNR{
   sikt=>pkt ;

VARIABLE ntal   \ antall nypkt

: KoplePkt ( -- flag ) \ overskytande eller likt
   ptal @
   kople-f kople-t \ kople-o
   ptal @ SWAP - 
   DUP ntal !
   DUP CR . ." nypkt utan koo" 
   3 * stal @ 3 * SWAP - 0< 0= ; \ ------------

\ kople orientering----------------------------------

variable sfranrgml  \ forrige stasjon
variable ornr       \ orienteringnr

: LagOkopling ( snr -- )  \ peikar fr sikt til OE{
	ornr @ swap ORNR{ swap } ! ;

: NyOv? ( snr -- f )  \ stasjonsnr ulikt forrige sikt
	dup  SFRANR{ swap } @ ( fnr ) sfranrgml @ <> ( snr f )
	HVvekt{ rot } @  AND ;

: KopleObs ( snr -- )
	dup NyOv? IF  
		SFRANR{ over } @ sfranrgml ! \ oppdater
		1 ornr +! 
	THEN  LagOkopling ;
	
: KopleOr  ( -- )
	-1 sfranrgml !   -1 ornr !
	AlleSikt DO
		i HarRetningsobs? IF  
			i KopleObs  
		ELSE  
			-1 ORNR{ i } !  -1 sfranrgml !
		THEN
	LOOP ;

: koplealt ( -- f )
	KoplePkt  if  KopleOr .UtSikt-k true  then ;
